Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::DenseSymMatrix Class Reference

Class for dense symetrix matrices. More...

`#include <IpDenseSymMatrix.hpp>`

Inheritance diagram for Ipopt::DenseSymMatrix:
[legend]

## Public Member Functions
SmartPtr< DenseSymMatrix > | MakeNewDenseSymMatrix () const
| Create a new DenseSymMatrix from same MatrixSpace. More...
Number * | Values ()
| Retrieve the array for storing the matrix elements. More...
const Number * | Values () const
| Retrieve the array that stores the matrix elements. More...
void | FillIdentity (Number factor=1.)
| Set this matrix to be a multiple of the identity matrix. More...
void | AddMatrix (Number alpha, const DenseSymMatrix &A, Number beta)
| Method for adding another matrix to this one. More...
void | HighRankUpdate (bool trans, Number alpha, const DenseGenMatrix &V, Number beta)
| Method for adding a high-rank update to this matrix. More...
void | HighRankUpdateTranspose (Number alpha, const MultiVectorMatrix &V1, const MultiVectorMatrix &V2, Number beta)
| Method for adding a high-rank update to this matrix. More...
void | SpecialAddForLMSR1 (const DenseVector &D, const DenseGenMatrix &L)
| Method for doing a specialized Add operation, required in the limited memory SR1 update. More...
Constructors / Destructors
| DenseSymMatrix (const DenseSymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
| ~DenseSymMatrix ()
| Destructor. More...
Public Member Functions inherited from Ipopt::SymMatrix
SmartPtr< const SymMatrixSpace > | OwnerSymMatrixSpace () const
| SymMatrix (const SymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~SymMatrix ()
| Destructor. More...
Index | Dim () const
| Dimension of the matrix (number of rows and columns) More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Overloaded methods from Matrix base class
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::SymMatrix
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Since the matrix is symmetric, it is only necessary to implement the MultVectorImpl method in a class that inherits from this base class. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Since the matrix is symmetric, the row and column max norms are identical. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| DenseSymMatrix ()
| Default Constructor. More...
| DenseSymMatrix (const DenseSymMatrix &)
| Copy Constructor. More...
void | operator= (const DenseSymMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
const DenseSymMatrixSpace * | owner_space_
Number * | values_
| Array for storing the matrix elements (one columns after each other) More...
bool | initialized_
| Flag indicating whether the values_ array has been initialized. More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for dense symetrix matrices.

Matrix elements are stored in one array in "Fortran" format, using BLAS "lower triangular" storage (not packed).

Definition at line 31 of file IpDenseSymMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::DenseSymMatrix::DenseSymMatrix | ( | const DenseSymMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::DenseSymMatrix::~DenseSymMatrix | ( |  | ) |

Destructor.

Ipopt::DenseSymMatrix::DenseSymMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::DenseSymMatrix::DenseSymMatrix | ( | const DenseSymMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

SmartPtr< DenseSymMatrix > Ipopt::DenseSymMatrix::MakeNewDenseSymMatrix | ( |  | ) | const
| inline

Create a new DenseSymMatrix from same MatrixSpace.

Definition at line 180 of file IpDenseSymMatrix.hpp.

Number* Ipopt::DenseSymMatrix::Values | ( |  | ) |
| inline

Retrieve the array for storing the matrix elements.

This is the non-const version, and it is assume that afterwards the calling method will set all matrix elements. The matrix elements are stored one column after each other.

Definition at line 53 of file IpDenseSymMatrix.hpp.

const Number* Ipopt::DenseSymMatrix::Values | ( |  | ) | const
| inline

Retrieve the array that stores the matrix elements.

This is the const version, i.e., read-only. The matrix elements are stored one column after each other.

Definition at line 63 of file IpDenseSymMatrix.hpp.

void Ipopt::DenseSymMatrix::FillIdentity | ( | Number | factor = `1.` | ) |

Set this matrix to be a multiple of the identity matrix.

void Ipopt::DenseSymMatrix::AddMatrix | ( | Number | alpha,
|  | const DenseSymMatrix & | A,
|  | Number | beta
| ) |  |

Method for adding another matrix to this one.

If B is this matrix, it becomes B = alpha * A + beta * B after this call.

void Ipopt::DenseSymMatrix::HighRankUpdate | ( | bool | trans,
|  | Number | alpha,
|  | const DenseGenMatrix & | V,
|  | Number | beta
| ) |  |

Method for adding a high-rank update to this matrix.

It computes M = alpha*op(V) op(V)^T + beta*M, where V is a DenseGenMatrix, where op(V) is V^T trans is true.

void Ipopt::DenseSymMatrix::HighRankUpdateTranspose | ( | Number | alpha,
|  | const MultiVectorMatrix & | V1,
|  | const MultiVectorMatrix & | V2,
|  | Number | beta
| ) |  |

Method for adding a high-rank update to this matrix.

It computes M = alpha*V1^T V2 + beta*M, where V1 and V2 are MultiVectorMatrices, so that V1^T V2 is symmetric.

void Ipopt::DenseSymMatrix::SpecialAddForLMSR1 | ( | const DenseVector & | D,
|  | const DenseGenMatrix & | L
| ) |  |

Method for doing a specialized Add operation, required in the limited memory SR1 update.

if M is this matrix, it computes M = M + D + L + L^T, where D is a diagonal matrix (given as a DenseVector), and L is a matrix that is assumed to be strictly lower triangular.

virtual void Ipopt::DenseSymMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::DenseSymMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::DenseSymMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::DenseSymMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::DenseSymMatrix::operator= | ( | const DenseSymMatrix & |  | ) |
| private

Overloaded Equals Operator.

## Member Data Documentation

const DenseSymMatrixSpace* Ipopt::DenseSymMatrix::owner_space_
| private

Definition at line 137 of file IpDenseSymMatrix.hpp.

Number* Ipopt::DenseSymMatrix::values_
| private

Array for storing the matrix elements (one columns after each other)

Definition at line 141 of file IpDenseSymMatrix.hpp.

bool Ipopt::DenseSymMatrix::initialized_
| private

Flag indicating whether the values_ array has been initialized.

Definition at line 144 of file IpDenseSymMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpDenseSymMatrix.hpp